package com.jwl.driver.server.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.jwl.driver.server.constant.Constants;
import com.jwl.driver.server.entity.TdSysConfig;
import com.jwl.driver.server.mapper.TdSysConfigMapper;
import com.jwl.driver.server.service.ITdSysConfigService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;

/**
 * <p>
 * 系统配置表; 服务实现类
 * </p>
 *
 * @author Automated procedures
 * @since 2023-08-10
 */
@Service
@Slf4j
public class TdSysConfigServiceImpl extends ServiceImpl<TdSysConfigMapper, TdSysConfig> implements ITdSysConfigService {

    @Override
    public TdSysConfig queryConfigByKey(String configKey, Integer carTypeId) {
        log.info("获取系统配置参数，configKey：{}", configKey);
        LocalDateTime now = LocalDateTime.now();
        LambdaQueryWrapper<TdSysConfig> queryWrapper = new QueryWrapper<TdSysConfig>().lambda()
                .eq(TdSysConfig::getCarTypeId,carTypeId)
                .eq(TdSysConfig::getConfigKey, configKey)
                .eq(TdSysConfig::getIsActive, Constants.IS_ACTIVE_TRUE);
        return getOne(queryWrapper);
    }

    @Override
    public String queryConfigValueByKey(String configKey, Integer carTypeId) {
        log.info("获取系统配置参数，configKey：{}", configKey);
        LocalDateTime now = LocalDateTime.now();
        LambdaQueryWrapper<TdSysConfig> queryWrapper = new QueryWrapper<TdSysConfig>().lambda()
                .eq(TdSysConfig::getCarTypeId,carTypeId)
                .eq(TdSysConfig::getConfigKey, configKey)
                .eq(TdSysConfig::getIsActive, Constants.IS_ACTIVE_TRUE);
        TdSysConfig config = getOne(queryWrapper);
        if(null == config) {
            return null;
        }
        return config.getConfigValue();
    }
}
